#define __spi_clock 13   // SCK - hardware SPI
#define __spi_latch 10
#define __spi_data 11    // MOSI - hardware SPI
#define __spi_data_in 12 // MISO - hardware SPI (unused)
#define __display_enable 9

#define __rows 16
#define __max_row __rows-1
#define __leds_per_row 8
#define __max_led __leds_per_row-1

#define __brightness_levels 16 // 0...15 above 28 is bad for ISR ( move to timer1, lower irq freq ! )
#define __max_brightness __brightness_levels-1
#define __fade_delay 4

#define __TIMER1_MAX 0xFFFF // 16 bit CTR
#define __TIMER1_CNT 0x0130 // 32 levels --> 0x0130; 38 --> 0x0157 (flicker)
#define __TIMER2_MAX 0xFF // 8 bit CTR
#define __TIMER2_CNT 0xFF // max 28 levels !

    float ball_x=4;
    float ball_y=4;
    float ball_dx=0;
    float ball_dy=0;
    
    float panel1 = 3;
    float panel2 = 5;    
    float dpanel1 = 1;
    float dpanel2 = -1;
    
    
void setup(void) {
  Serial.begin(9600);
  randomSeed(555);
  
  matrix_setup();  
  set_matrix_rgb(0,0,0);
  
  ball_dx=0.5+random(10)/10.0;
  ball_dy=0.5+random(10)/10.0;
}


          

    
void loop(void) {
    int hit1=0;
    int hit2=0;
    
    set_led_rgb(ball_y,ball_x,0,0,0);
    ball_x+=ball_dx;
    ball_y+=ball_dy;

    if (ball_y <= 0) {
        ball_y=0;
        ball_dy *= -(1+(random(10.0)-5)/10.0);
        if(ball_dy < 0.5) {
            ball_dy=0.5;
        }
    }
    
    if (ball_y >= __rows-1) {
        ball_y=__rows-1;
        ball_dy *= -(1+(random(10.0)-5)/10.0);
        if(ball_dy > -0.5) {
            ball_dy=-0.5;
        }
    }
    
    if (ball_x < 1) {
        ball_x=1;
        ball_dx *= -(1+(random(10.0)-5)/10.0);
        if(ball_dx < 0.5) {
            ball_dx=0.5;
        }
        hit1=1;
    }
    
    if (ball_x > 6) {
        ball_x=6;
        ball_dx *= -(1+(random(10.0)-5)/10.0);
        if(ball_dx > -0.5) {
            ball_dx=-0.5;
        }
        hit2=1;
    }    
    
    
    int ziel_x;
    if(ball_dx > 0) {
        ziel_x=7;
    } else {
        ziel_x=0;
    }
     
     float t=(ziel_x-ball_x) / ball_dx;
     
     int ziel_y;
     ziel_y=ball_y + t*ball_dy;
     
     if (ziel_y > 16) {
         ziel_y = ziel_y - ( ziel_y - 16);
     }
     if  (ziel_y < 0) {
         ziel_y *= -1;
     }     
     
     if(1 || ball_dx > 0) {
         if (panel2 < ziel_y-1) {
             dpanel2 = 0.5+random(2);
         }
         
         if (panel2 > ziel_y-1) {
             dpanel2 = -0.5-random(2);
         }
         if(panel2 == ziel_y-1) {
             dpanel2=0;
         }
         //dpanel1=0;
     }

     if(1 || ball_dx < 0) {
         if (panel1 < ziel_y-1) {
             dpanel1 = 0.5+random(2);
         }
         
         if (panel1 > ziel_y-1) {
             dpanel1 = -0.5-random(2);
         }
         if(panel1 == ziel_y-1) {
             dpanel1=0;
         }
         //dpanel2=0;
     }

   
   panel1 += dpanel1;

  if(panel1 >= 13) {
       dpanel1 *= -1;
       panel1=13;
   }
   if(panel1 <= 0 ) {
       dpanel1 *= -1;
       panel1=0;
   }

   panel2 += dpanel2;
   if(panel2 >= 13) {
       dpanel2 *= -1;
       panel2=13;
   }
   if(panel2 <= 0 ) {
       dpanel2 *= -1;
       panel2=0;
   }


    set_led_rgb(ball_y,ball_x,255,0,0);     
    draw_panels(panel1,hit1,panel2,hit2);
    
    /*
Serial.print("x:");    Serial.print(ball_x); 
Serial.print("  y:");  Serial.print(ball_y);
Serial.print("  dx:"); Serial.print(ball_dx);
Serial.print("  dy:"); Serial.print(ball_dy);   
Serial.print("  zx:"); Serial.print(ziel_x); 
Serial.print("  zy:"); Serial.print(ziel_y);
Serial.print("  p1:"); Serial.print(panel1); 
Serial.print("  p2:"); Serial.print(panel2);

Serial.println();
*/
   delay(100);
}

void draw_panels(int panel1, int hit1, int panel2, int hit2) {
    // panel1
    for (int row=0;row<16; row++) {
        if(row >= panel1 and row < panel1 + 3) {
          set_led_rgb(row,0,255,(hit1 ? 0 : 255),255);
        } else {
          set_led_rgb(row,0,0,0,0);
        }
    }
    
    // panel2
    for (int row=0;row<16; row++) {
        if(row >= panel2 and row < panel2 + 3) {
          set_led_rgb(row,7,255,255,(hit2 ? 0 : 255));
        } else {
          set_led_rgb(row,7,0,0,0);
        }
    }

}


